var port = process.env.PORT || 4000,
    app = require('./app').init(port),
	opa = require('one-page-app'),
	conf = opa.conf({host:'127.0.0.1',port:'5984',db:'apps'});
	
var locals = {
	author:'in1'
	// add other vars here
};

app.get('*', function(req,res,next){
	if (req.session) {
		locals.session=req.session;
		locals.once="";
	}
	
	next();
});

app.get('/', function(req,res){
	console.log("show home page");
    return opa.index(req,res);   
});

app.get('/login', function(req,res){
	console.log("show login page");
	return opa.login(req,res); 
});

app.post('/login', function(req,res){
	return opa.login.post(req,res); 
});

app.get('/logout', function(req,res){
	console.log("logging out");
	return opa.logout(req,res); 
});

app.get('/admin', function(req,res){
	return opa.admin(req,res); 
});

app.post('/admin/app', function(req,res){
	return opa.admin.app(req,res); 
});

app.post('/admin/page', function(req,res){
	console.log("saving page settings..");
	return opa.admin.page(req,res); 
});

app.post('/admin/sections', function(req,res){
	console.log("creating new section..");
	return opa.admin.sections(req,res);
});

app.post('/admin/sections/:k', function(req,res){
	console.log("saving section..");
	return opa.admin.sections.post(req,res);
});

app.del('/admin/sections/:k', function(req,res){
	console.log("deleting section..");
	return opa.admin.sections.del(req,res);
})

app.post('/admin/sections/all', function(req,res){
	console.log("saving all sections..");
	return opa.admin.sections.all(req,res);
});

app.post('/admin/sections', function(req,res){
	console.log("saving sections..");
	return opa.admin.sections.all.post(req,res);
});

app.get('/admin/snippets/:k', function(req,res){
	console.log("getting snippet..");
	return opa.admin.snippets(req,res);
});

app.post('/admin/snippets/:k', function(req,res){
	console.log("saving snippet..");
	return opa.admin.snippets.post(req,res);
});

app.del('/admin/snippets/:k', function(req,res){
	console.log("deleting snippet..");
	return opa.admin.snippets.del(req,res)
})

app.post('/contact', function(req,res){
	console.log('contact form submit..');
	return opa.admin.contact(req,res)
});

/* add more routes here */
app.get('/about', function(req,res){
	res.send("hello world");
});


/* 404 Route (ALWAYS keep this as the last route) */
app.get('/*', function(req, res){
    res.render('404.ejs', locals);
});


/* utils */
function validateEmail (value) {
  var isValid = /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i.test(value);
  return isValid;
}

